`dbrepos`: Repository-Pattern Implementation for Python
=======================================

[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)
[![Coverage Status](https://coveralls.io/repos/github/MatveyIvanov/dbrepos/badge.svg?branch=main)](https://coveralls.io/github/MatveyIvanov/dbrepos?branch=main)
![GitHub License](https://img.shields.io/github/license/MatveyIvanov/dbrepos)
![PyPI - Version](https://img.shields.io/pypi/v/dbrepos)
![PyPI - Python Version](https://img.shields.io/pypi/pyversions/dbrepos)
![PyPI - Wheel](https://img.shields.io/pypi/wheel/dbrepos)
![GitHub Actions Workflow Status](https://img.shields.io/github/actions/workflow/status/MatveyIvanov/dbrepos/test-ci.yml?branch=main)

What is `dbrepos`?
-------------

See [the documentation](https://dbrepos.readthedocs.io/en/latest/) for
more examples and information.

Quick start
-----------

`dbrepos` can be installed using pip:

```bash
python3 -m pip install -U dbrepos
```

If you want to run the latest version of the code, you can install from the
github directly:

```bash
python3 -m pip install -U git+https://github.com/MatveyIvanov/dbrepos.git
```

Contributing
------------

Help in testing, development, documentation and other tasks is
highly appreciated and useful to the project.

To get started with developing `dbrepos`, see [CONTRIBUTING.md](CONTRIBUTING.md).

Stable release roadmap
----------------------------------
* Unit tests for repositories methods
* 100% test coverage
* async API for SQLAlchemy
* Support for both SQLAlchemy's table API's
* 100% documentation coverage
* Automated package deployment
* Automated testing, linting and more for PRs, merges to main and tags
* Automated badges updates after CI
* Automated docs updates after CI
* Hosted docs
* Ready-to-use fixtures for testing outside the package
* Finalized README, CONTRIBUTING, CHANGELOG
* ...
